﻿using System.Runtime.InteropServices;

class Tusbs03cn3
{
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Device_Open(short id);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbs03cn3_Device_Close(short id);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Cycle_Set(short id,byte ch,int Time);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Counter_Start(short id,byte ch,byte Mode);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Counter_Stop(short id,byte ch);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Status_Read(short id, byte ch, out byte UpdateChk);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Counter_Read(short id, byte ch, out int DataH, out int DataL);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Fifo_Cnt(short id, byte ch, out short Cnt);
    [DllImport("TUSBSCN3.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs03cn3_Fifo_Read(short id,  byte ch, ref short Leng,[Out] int[] DataH,[Out] int[] DataL);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}