﻿Public Class Form1
    Const DevId As Short = 0 ' デバイスIDを0とする
    Private CntMode(2) As Byte

    'コントロールの配列
    'この配列を通してコントロールを使用します。
    Private ArryModeSoft() As System.Windows.Forms.RadioButton
    Private ArryModeLoad() As System.Windows.Forms.RadioButton
    Private ArryModeLogger() As System.Windows.Forms.RadioButton
    Private ArryCmdStart() As System.Windows.Forms.Button
    Private ArryCycle() As System.Windows.Forms.TextBox
    Private ArryFifoLen() As System.Windows.Forms.Label
    Private ArryCount() As System.Windows.Forms.Label
    Private ArryCountList() As System.Windows.Forms.ListBox
    Private ArryTimer() As System.Windows.Forms.Timer

    '設定の初期化
    Private Sub SettingInit()
        Dim ch As Integer

        'コントロールの配列に画面のコントロールを設定します
        ArryModeSoft = New System.Windows.Forms.RadioButton() {Mode_Soft1, Mode_Soft2, Mode_Soft3}
        ArryModeLoad = New System.Windows.Forms.RadioButton() {Mode_Load1, Mode_Load2, Mode_Load3}
        ArryModeLogger = New System.Windows.Forms.RadioButton() {Mode_Logger1, Mode_Logger2, Mode_Logger3}
        ArryCmdStart = New System.Windows.Forms.Button() {CmdStart1, CmdStart2, CmdStart3}
        ArryCycle = New System.Windows.Forms.TextBox() {Cycle1, Cycle2, Cycle3}
        ArryFifoLen = New System.Windows.Forms.Label() {FifoLen1, FifoLen2, FifoLen3}
        ArryCount = New System.Windows.Forms.Label() {Count1, Count2, Count3}
        ArryCountList = New System.Windows.Forms.ListBox() {CountLst1, CountLst2, CountLst3}
        ArryTimer = New System.Windows.Forms.Timer() {Timer1, Timer2, Timer3}

        For ch = 0 To 2
            '各コントロールのTagにchを設定して後で操作に使用します
            ArryModeSoft(ch).Tag = ch
            ArryModeLoad(ch).Tag = ch
            ArryModeLogger(ch).Tag = ch
            ArryCmdStart(ch).Tag = ch
            ArryCycle(ch).Tag = ch
            ArryFifoLen(ch).Tag = ch
            ArryCount(ch).Tag = ch
            ArryCountList(ch).Tag = ch
            ArryTimer(ch).Tag = ch

            '各コントロールに値を設定初期化します
            ArryModeSoft(ch).Checked = True 'ソフトモードに設定

        Next ch
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim retcode As Short

        'デバイスオープン
        Try
            retcode = Tusbs03cn3_Device_Open(DevId)
            If retcode <> 0 Then
                MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
                Me.Close()
            Else
                SettingInit() '初期設定
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Me.Close()
        End Try
    End Sub

    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Dim ch As Byte

        For ch = 0 To 2
            If ArryCmdStart(ch).Text = "CntStop" Then
                Sub_Stop(ch)
            End If
        Next

        Tusbs03cn3_Device_Close(DevId)
    End Sub

    Private Sub Sub_Start(ByVal ch As Byte)
        Dim retcode As Short
        If ArryModeSoft(ch).Checked Then
            CntMode(ch) = 0
        ElseIf ArryModeLoad(ch).Checked Then
            CntMode(ch) = 1
        Else
            CntMode(ch) = 2
            ArryCountList(ch).Items.Clear()
        End If

        If CntMode(ch) <> 0 Then
            retcode = Tusbs03cn3_Cycle_Set(DevId, ch, CInt(ArryCycle(ch).Text))
            If retcode Then
                MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
                Exit Sub
            End If
        End If

        retcode = Tusbs03cn3_Counter_Start(DevId, ch, CntMode(ch))
        If retcode Then
            MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
            Exit Sub
        End If

        ArryCmdStart(ch).Text = "CntStop"
        ArryModeSoft(ch).Enabled = False
        ArryModeLoad(ch).Enabled = False
        ArryModeLogger(ch).Enabled = False
        ArryCycle(ch).Enabled = False

        ArryTimer(ch).Enabled = True
    End Sub

    Private Sub Sub_Stop(ByVal ch As Byte)
        Dim retcode As Short

        ArryTimer(ch).Enabled = False
        retcode = Tusbs03cn3_Counter_Stop(DevId, ch)
        If retcode Then
            MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
        End If

        ArryCmdStart(ch).Text = "CntStart"
        ArryModeSoft(ch).Enabled = True
        ArryModeLoad(ch).Enabled = True
        ArryModeLogger(ch).Enabled = True
        ArryCycle(ch).Enabled = True
    End Sub

    Private Sub CmdStart_Click(sender As System.Object, e As System.EventArgs) Handles CmdStart1.Click, CmdStart3.Click, CmdStart2.Click
        Dim tmpControl As Button = TryCast(sender, Button)
        Dim ch As Byte = CByte(tmpControl.Tag)

        If tmpControl.Text = "CntStart" Then
            Sub_Start(ch)
        Else
            Sub_Stop(ch)
        End If
    End Sub

    Private Sub Timer_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick, Timer3.Tick, Timer2.Tick
        Dim retcode As Short
        Dim DataH As Integer
        Dim DataL As Integer
        Dim FifoH(512) As Integer
        Dim FifoL(512) As Integer
        Dim tmpN As Decimal
        Dim UpdateChk As Byte
        Dim FifoCnt As Short
        Dim cntL As Integer
        Dim tmpControl As Timer = TryCast(sender, Timer)
        Dim ch As Byte = CByte(tmpControl.Tag)

        Select Case CntMode(ch)
            Case 0 'Mode soft
                retcode = Tusbs03cn3_Counter_Read(DevId, ch, DataH, DataL)
                If retcode Then
                    MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
                    ArryTimer(ch).Enabled = False
                    Exit Sub
                End If
                tmpN = CDec(DataL) + CDec(DataH) * &H10000
                ArryCount(ch).Text = tmpN.ToString()
            Case 1 'Mode Load
                retcode = Tusbs03cn3_Status_Read(DevId, ch, UpdateChk)
                If retcode Then
                    MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
                    ArryTimer(ch).Enabled = False
                    Exit Sub
                End If
                If UpdateChk Then
                    retcode = Tusbs03cn3_Counter_Read(DevId, ch, DataH, DataL)
                    If retcode Then
                        MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
                        ArryTimer(ch).Enabled = False
                        Exit Sub
                    End If
                    tmpN = CDec(DataL) + CDec(DataH) * &H10000
                    ArryCount(ch).Text = tmpN.ToString()
                End If
            Case 2 'Mode Logger
                retcode = Tusbs03cn3_Fifo_Cnt(DevId, ch, FifoCnt)
                If retcode Then
                    MessageBox.Show(Tusbs03cn3_GetErrMessage(retcode))
                    ArryTimer(ch).Enabled = False
                    Exit Sub
                End If

                ArryFifoLen(ch).Text = FifoCnt.ToString("d")

                If FifoCnt Then
                    retcode = Tusbs03cn3_Fifo_Read(DevId, ch, FifoCnt, FifoH, FifoL)
                    For cntL = 0 To FifoCnt - 1
                        tmpN = CDec(FifoL(cntL)) + CDec(FifoH(cntL)) * &H10000
                        Dim ItemCountStr As String = "[" & ArryCountList(ch).Items.Count.ToString("d") & "]"
                        Dim CountStr As String = tmpN.ToString()
                        ArryCountList(ch).Items.Add(ItemCountStr & "   " & CountStr)
                        If ArryCountList(ch).Items.Count >= 32767 Then
                            Sub_Stop(ch)
                            MessageBox.Show("取り込み数が上限(32767個)になりました")
                            ArryCountList(ch).TopIndex = 32766
                            Exit Sub
                        End If
                    Next
                    If ArryCountList(ch).Items.Count Then
                        ArryCountList(ch).TopIndex = ArryCountList(ch).Items.Count - 1
                    End If
                End If
        End Select
    End Sub
End Class
