﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S03CN3Sample
{
    public partial class Form1 : Form
    {
        const short DevId = 0; //デバイスIDは0固定
        byte[] CntMode = new byte[3];

        //コントロールの配列
        //この配列を通してコントロールを使用します。
        private System.Windows.Forms.RadioButton[] ArryModeSoft;
        private System.Windows.Forms.RadioButton[] ArryModeLoad;
        private System.Windows.Forms.RadioButton[] ArryModeLogger;
        private System.Windows.Forms.Button[] ArryCmdStart;
        private System.Windows.Forms.TextBox[] ArryCycle;
        private System.Windows.Forms.Label[] ArryFifoLen;
        private System.Windows.Forms.Label[] ArryCount;
        private System.Windows.Forms.ListBox[] ArryCountList;
        private System.Windows.Forms.Timer[] ArryTimer;

        public Form1()
        {
            InitializeComponent();
        }

        private void SettingInit()
        {
            int ch;

            //コントロールの配列に画面のコントロールを設定します
            ArryModeSoft = new System.Windows.Forms.RadioButton[] { Mode_Soft1, Mode_Soft2, Mode_Soft3 };
            ArryModeLoad = new System.Windows.Forms.RadioButton[] { Mode_Load1, Mode_Load2, Mode_Load3 };
            ArryModeLogger = new System.Windows.Forms.RadioButton[] { Mode_Logger1, Mode_Logger2, Mode_Logger3 };
            ArryCmdStart = new System.Windows.Forms.Button[] { CmdStart1, CmdStart2, CmdStart3 };
            ArryCycle = new System.Windows.Forms.TextBox[] { Cycle1, Cycle2, Cycle3 };
            ArryFifoLen = new System.Windows.Forms.Label[] { FifoLen1, FifoLen2, FifoLen3 };
            ArryCount = new System.Windows.Forms.Label[] { Count1, Count2, Count3 };
            ArryCountList = new System.Windows.Forms.ListBox[] { CountLst1, CountLst2, CountLst3 };
            ArryTimer = new System.Windows.Forms.Timer[] { Timer1, Timer2, Timer3 };

            for (ch = 0; ch < 3; ch++)
            {
                //各コントロールのTagにchを設定して後で操作に使用します
                ArryModeSoft[ch].Tag = (byte)ch;
                ArryModeLoad[ch].Tag = (byte)ch;
                ArryModeLogger[ch].Tag = (byte)ch;
                ArryCmdStart[ch].Tag = (byte)ch;
                ArryCycle[ch].Tag = (byte)ch;
                ArryFifoLen[ch].Tag = (byte)ch;
                ArryCount[ch].Tag = (byte)ch;
                ArryCountList[ch].Tag = (byte)ch;
                ArryTimer[ch].Tag = (byte)ch;

                //各コントロールに値を設定初期化します
                ArryModeSoft[ch].Checked = true;//ソフトモードに設定
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short retcode;

            //デバイスオープン
            try
            {
                if ((retcode = Tusbs03cn3.Tusbs03cn3_Device_Open(DevId)) != 0)
                {
                    MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                    this.Close();
                }
                else
                {
                    SettingInit();//初期設定
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                this.Close();
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            byte ch;

            for (ch = 0; ch < 3; ch++)
            {
                if (ArryCmdStart[ch].Text == "CntStop")
                    Sub_Stop(ch);
            }

            Tusbs03cn3.Tusbs03cn3_Device_Close(DevId);//デバイスクローズ
        }

        private void Sub_Start(byte ch)
        {
            short retcode;

            if (ArryModeSoft[ch].Checked)
                CntMode[ch] = 0;
            else if (ArryModeLoad[ch].Checked)
                CntMode[ch] = 1;
            else
            {
                CntMode[ch] = 2;
                ArryCountList[ch].Items.Clear();
            }

            if (CntMode[ch] != 0)
            {
                if ((retcode = Tusbs03cn3.Tusbs03cn3_Cycle_Set(DevId, ch, Convert.ToInt32(ArryCycle[ch].Text))) != 0)
                {
                    MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                    return;
                }
            }

            if ((retcode = Tusbs03cn3.Tusbs03cn3_Counter_Start(DevId, ch, CntMode[ch])) != 0)
            {
                MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                return;
            }

            ArryCmdStart[ch].Text = "CntStop";
            ArryModeSoft[ch].Enabled = false;
            ArryModeLoad[ch].Enabled = false;
            ArryModeLogger[ch].Enabled = false;
            ArryCycle[ch].Enabled = false;

            ArryTimer[ch].Enabled = true;
        }

        private void Sub_Stop(byte ch)
        {
            short retcode;

            ArryTimer[ch].Enabled = false;
            if ((retcode = Tusbs03cn3.Tusbs03cn3_Counter_Stop(DevId, ch)) != 0)
            {
                MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
            }

            ArryCmdStart[ch].Text = "CntStart";
            ArryModeSoft[ch].Enabled = true;
            ArryModeLoad[ch].Enabled = true;
            ArryModeLogger[ch].Enabled = true;
            ArryCycle[ch].Enabled = true;
        }

        private void CmdStart_Click(object sender, EventArgs e)
        {
            Button tmpControl = (Button)sender;
            byte ch = (byte) tmpControl.Tag;

            if (tmpControl.Text == "CntStart")
                Sub_Start(ch);
            else
                Sub_Stop(ch);
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            short retcode;
            int DataH;
            int DataL;
            int[] FifoH = new int[512];
            int[] FifoL = new int[512];
            decimal tmpN;
            byte UpdateChk;
            short FifoCnt;
            int cntL;
            Timer tmpControl = (Timer)sender;
            byte ch = (byte)tmpControl.Tag;

            switch (CntMode[ch])
            {
                case 0://Mode soft
                    if ((retcode = Tusbs03cn3.Tusbs03cn3_Counter_Read(DevId, ch, out DataH, out DataL)) != 0)
                    {
                        MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                        ArryTimer[ch].Enabled = false;
                        return;
                    }
                    tmpN = (decimal)DataL + (decimal)DataH * 0x10000;
                    ArryCount[ch].Text = tmpN.ToString();
                    break;
                case 1://Mode Load
                    if ((retcode = Tusbs03cn3.Tusbs03cn3_Status_Read(DevId, ch,out UpdateChk)) != 0)
                    {
                        MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                        ArryTimer[ch].Enabled = false;
                        return;
                    }
                    if (UpdateChk != 0 )
                    {
                        if ((retcode = Tusbs03cn3.Tusbs03cn3_Counter_Read(DevId, ch, out DataH, out DataL)) != 0)
                        {
                            MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                            ArryTimer[ch].Enabled = false;
                            return;
                        }
                        tmpN = (decimal)DataL + (decimal)DataH * 0x10000;
                        ArryCount[ch].Text = tmpN.ToString();
                    }
                    break;
                case 2://Mode Logger
                    if ((retcode = Tusbs03cn3.Tusbs03cn3_Fifo_Cnt(DevId, ch, out FifoCnt)) != 0)
                    {
                        MessageBox.Show(Tusbs03cn3.GetErrMessage(retcode));
                        ArryTimer[ch].Enabled = false;
                        return;
                    }

                    ArryFifoLen[ch].Text = FifoCnt.ToString("d");

                    if (FifoCnt != 0)
                    {
                        retcode = Tusbs03cn3.Tusbs03cn3_Fifo_Read(DevId, ch, ref FifoCnt, FifoH, FifoL);
                        for (cntL = 0; cntL < FifoCnt; cntL++)
                        {
                            tmpN = (decimal)FifoL[cntL] + (decimal)FifoH[cntL] * 0x10000;
                            string ItemCountStr = "[" + ArryCountList[ch].Items.Count.ToString("d") + "]";
                            string CountStr = tmpN.ToString();
                            ArryCountList[ch].Items.Add(ItemCountStr + "   " + CountStr);
                            if (ArryCountList[ch].Items.Count >= 32767)
                            {
                                Sub_Stop(ch);
                                MessageBox.Show("取り込み数が上限(32767個)になりました");
                                ArryCountList[ch].TopIndex = 32766;
                                return;
                            }
                        }
                        if (ArryCountList[ch].Items.Count > 0)
                        {
                            ArryCountList[ch].TopIndex = ArryCountList[ch].Items.Count - 1;
                        }
                    }
                    break;
            }
        }
    }
}
